#! /usr/bin/python2.7
# -*- coding: UTF-8 -*-

import time
import threading
import socket
import sys
sys.path.append("./OSC")
sys.path.append("./pyFluidSynth")
import OSC
import re

config = {  0: ('localhost', 12000, 1024),
            1: ('10.0.0.4', 8000, 1024),
            2: ('localhost', 13000, 1024)   }

attribution = { "n0_1_push1": 0,
                "n0_1_push10": 0,
                "n0_1_push11": 0,
                "n0_1_push12": 0,
                "n0_1_push2": 0,
                "n0_1_push3": 0,
                "n0_1_push4": 0,
                "n0_1_push5": 0,
                "n0_1_push6": 0,
                "n0_1_push7": 0,
                "n0_1_push8": 0,
                "n0_1_push9": 0,
                "n0_1_fader1": 0,
                "n0_1_fader2": 0,
                "n0_1_fader3": 0,
                "n0_1_fader4": 0,
                "n0_1_fader5": 0,
                "n0_1_toggle1": 0,
                "n0_1_toggle2": 0,
                "n0_1_toggle3": 0,
                "n0_1_toggle4": 0,
                "n0_2": 0,
                "n0_2_push1": 0,
                "n0_2_push10": 0,
                "n0_2_push11": 0,
                "n0_2_push12": 0,
                "n0_2_push13": 0,
                "n0_2_push14": 0,
                "n0_2_push15": 0,
                "n0_2_push16": 0,
                "n0_2_push2": 0,
                "n0_2_push3": 0,
                "n0_2_push4": 0,
                "n0_2_push5": 0,
                "n0_2_push6": 0,
                "n0_2_push7": 0,
                "n0_2_push8": 0,
                "n0_2_push9": 0,
                "n0_2_toggle1": 0,
                "n0_2_toggle2": 0,
                "n0_2_toggle3": 0,
                "n0_2_toggle4": 0,
                "n0_3": 0,
                "n0_3_toggle1": 0,
                "n0_3_toggle2": 0,
                "n0_3_toggle3": 0,
                "n0_3_toggle4": 0,
                "n0_3_xy": 0,
                "n0_4": 0,
                "n0_4_multitoggle_1_1": 0,
                "n0_4_multitoggle_1_2": 0,
                "n0_4_multitoggle_1_3": 0,
                "n0_4_multitoggle_1_4": 0,
                "n0_4_multitoggle_1_5": 0,
                "n0_4_multitoggle_1_6": 0,
                "n0_4_multitoggle_1_7": 0,
                "n0_4_multitoggle_1_8": 0,
                "n0_4_multitoggle_2_1": 0,
                "n0_4_multitoggle_2_2": 0,
                "n0_4_multitoggle_2_3": 0,
                "n0_4_multitoggle_2_4": 0,
                "n0_4_multitoggle_2_5": 0,
                "n0_4_multitoggle_2_6": 0,
                "n0_4_multitoggle_2_7": 0,
                "n0_4_multitoggle_2_8": 0,
                "n0_4_multitoggle_3_1": 0,
                "n0_4_multitoggle_3_2": 0,
                "n0_4_multitoggle_3_3": 0,
                "n0_4_multitoggle_3_4": 0,
                "n0_4_multitoggle_3_5": 0,
                "n0_4_multitoggle_3_6": 0,
                "n0_4_multitoggle_3_7": 0,
                "n0_4_multitoggle_3_8": 0,
                "n0_4_multitoggle_4_1": 0,
                "n0_4_multitoggle_4_2": 0,
                "n0_4_multitoggle_4_3": 0,
                "n0_4_multitoggle_4_4": 0,
                "n0_4_multitoggle_4_5": 0,
                "n0_4_multitoggle_4_6": 0,
                "n0_4_multitoggle_4_7": 0,
                "n0_4_multitoggle_4_8": 0,
                "n0_4_multitoggle_5_1": 0,
                "n0_4_multitoggle_5_2": 0,
                "n0_4_multitoggle_5_3": 0,
                "n0_4_multitoggle_5_4": 0,
                "n0_4_multitoggle_5_5": 0,
                "n0_4_multitoggle_5_6": 0,
                "n0_4_multitoggle_5_7": 0,
                "n0_4_multitoggle_5_8": 0,
                "n0_4_multitoggle_6_1": 0,
                "n0_4_multitoggle_6_2": 0,
                "n0_4_multitoggle_6_3": 0,
                "n0_4_multitoggle_6_4": 0,
                "n0_4_multitoggle_6_5": 0,
                "n0_4_multitoggle_6_6": 0,
                "n0_4_multitoggle_6_7": 0,
                "n0_4_multitoggle_6_8": 0,
                "n0_4_multitoggle_7_1": 0,
                "n0_4_multitoggle_7_2": 0,
                "n0_4_multitoggle_7_3": 0,
                "n0_4_multitoggle_7_4": 0,
                "n0_4_multitoggle_7_5": 0,
                "n0_4_multitoggle_7_6": 0,
                "n0_4_multitoggle_7_7": 0,
                "n0_4_multitoggle_7_8": 0,
                "n0_4_multitoggle_8_1": 0,
                "n0_4_multitoggle_8_2": 0,
                "n0_4_multitoggle_8_3": 0,
                "n0_4_multitoggle_8_4": 0,
                "n0_4_multitoggle_8_5": 0,
                "n0_4_multitoggle_8_6": 0,
                "n0_4_multitoggle_8_7": 0,
                "n0_4_multitoggle_8_8": 0,
                "n0_4_toggle1": 0,
                "n0_4_toggle2": 0,
                "n0_4_toggle3": 0,
                "n0_4_toggle4": 0
}

var_dict ={}
socketOSC = []
tempo, adress = 0 , (0,0)

def main():
    set_audio()
    plug()
    listen()

def plug():
    for key in config.keys():
        ip = config[key][0]
        port = config[key][1]
        buffer_size = config[key][2]
        socketOSC.append(0)
        socketOSC[key] = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        try:
            socketOSC[key].bind((ip, port))
            socketOSC[key].setblocking(0)
            socketOSC[key].settimeout(0.002)
            socketOSC[key].setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, buffer_size)
            print('Plug : IP = {} Port = {} Buffer Size = {} Socket = {}'.format(ip, port, buffer_size, n))
        except:
            print('No connected to IP = {} Port = {}'.format(ip, port))
            pass

def listen():
    while 1:
        for key in config.keys():
            try:
                time.sleep(0.01)
                global adress
                raw_data = socketOSC[key].recv(config[key][2])
                data = OSC.decodeOSC(raw_data)
                convert_data(data, key)
            except socket.error:
                pass

def convert_data(data, n):
    '''Convert OSC message in variable'''
    # if list
    if isinstance(data, list):
        if len(data) > 1 :
            # if bundle cut bundle and time
            if data[0]=='#bundle':
                # Cut the two first item
                data = data[2:]
            test_if_list_of_list(data, n)
    else:
        pass

def test_if_list_of_list(data, n):
    '''test if first in list is a list'''
    if isinstance(data[0], list):
        for i in range(len(data)):
            list_to_var(data[i])
    else:
        list_to_var(data, n)

def list_to_var(data, n):
    '''Set value in variable'''
    # First item is the tag, otherwise message in not osc
    var_name = name(data[0], n)
    # if the second is type of all values, example 'iif
    if isinstance(data[1], str) or data[1][0] == ",":
        # cut the 2 first
        data = data[2:]
    # cut the first: msg don't respect OSC format
    else:
        data = data[1:]
    # data is always list, convert list to int or float or str if len=1
    if len(data)==1:
        data = data[0]

    if var_name in var_dict:
        if var_dict[var_name] != data:
            var_dict[var_name] = data
            musik(var_name)
    else:
        var_dict[var_name] = data
        musik(var_name)

    global tempo
    tempo += 1
    if tempo == 100:
        tempo = 0
        print var_dict

def musik(var_name):
    note = 12
    duree = 0.2
    chan = 6

    # Get fader
    if var_name.find('fader') != -1:
        print 'fader'
    # Get toggle
    if var_name.find('toggle') != -1:
        print 'toggle'
    # Get last ex 5_4
    if var_name.find('multitoggle') != -1:
        print 'multitoggle', var_name[-3:]
        note = 10 + 3*int(var_name[-3:][:1]) + 4*int(var_name[-3:][-1:])
    # Get push
    if var_name.find('push') != -1:
        print 'push'
    # get panel
    print 'panel', var_name[3:4]
    # get socket number
    print 'socket', var_name[1:2]

    ##if isinstance(var_dict[var_name], float):
        ##note = int(100*var_dict[var_name])

    thread3=threading.Thread(target=playN, args=(note, duree, chan))
    thread3.start()

def set_audio():
    try:
        import fluidsynth
        global fs
        fs = fluidsynth.Synth()
        fs.start(driver='alsa')
        # This path is a problem
        sfid = fs.sfload("/usr/share/sounds/sf2/FluidR3_GM.sf2")
        fs.program_select(0, sfid, 0, 12)
        fs.program_select(1, sfid, 0, 12)
        fs.program_select(2, sfid, 0, 12)
        fs.program_select(3, sfid, 0, 12)
        fs.program_select(4, sfid, 0, 64)
        fs.program_select(5, sfid, 0, 64)
        fs.program_select(6, sfid, 0, 64)
        fs.program_select(7, sfid, 0, 64)
        fs.program_select(8, sfid, 0, 127)
        fs.program_select(8, sfid, 0, 127)
    except:
        print ("For sound synthetizer, you must install:")
        print ("sudo apt-get install fluidsynth fluid-soundfont-gm fluid-soundfont-gs")
        pass

def name(s, n):
    '''Convert s in variable name'''
    # Cut the first / if
    if s[0] == '/':
        s = s[1:]
    # add socket number in front to identify the socket and separate identical name
    # so the first item is never a number
    s = 'n' + str(n) + '_' + s
    # Replace / or - or , with _ (add str in list if necessary)
    for i in ['/', '-', ',']:
        s = s.replace(i, '_')
    return s

def playN(note, duree, chan):
    fs.noteon(chan, note, 127)
    time.sleep(duree)
    fs.noteoff(chan, note)

main()
